                 LIST P=16F628
                 __CONFIG H'3F40'
W                EQU             0
F                EQU             1
INDF             EQU             00H
TMR0             EQU             01H
PCL              EQU             02H
STATUS           EQU             03H
FSR              EQU             04H
PORTA            EQU             05H
PORTB            EQU             06H
INTCON           EQU             0BH
CMCON            EQU             1FH
OPTION_REG       EQU             01H
TRISA            EQU             05H
TRISB            EQU             06H
IRP              EQU             7
RP0              EQU             5
Z                EQU             2
C                EQU             0
DC               EQU             1
GIE              EQU             7
T0IE             EQU             5
T0IF             EQU             2
;
H2               EQU             21H
H1               EQU             22H
M2               EQU             24H
M1               EQU             28H
N                EQU             70H
SEG_H            EQU             23H
W_TMP            EQU             25H
STATUS_TMP       EQU             26H
MIN              EQU             27H
KEY              EQU             29H
;
;
;
                 ORG             0000
                 GOTO            INIT
                 ORG             0004
                 GOTO            CLOCK
;
SEGMENT	         ADDWF	         PCL,F            ;    7-
                 RETLW  	 B'00000010'			;0
                 RETLW  	 B'01111010'			;1
                 RETLW  	 B'00100100'			;2
                 RETLW  	 B'00101000'			;3
                 RETLW  	 B'01011000'			;4
                 RETLW  	 B'10001000'			;5
                 RETLW  	 B'10000000'			;6
                 RETLW  	 B'00011010'			;7
                 RETLW  	 B'00000000'			;8
                 RETLW  	 B'00001000'			;9
;
INIT             BSF             INTCON,T0IE       ;  
                 BSF             STATUS,RP0
                 MOVLW           H'D3'
                 MOVWF           OPTION_REG
                 MOVLW           B'11110000'
                 MOVWF           TRISA
                 CLRF            TRISB
                 BCF             STATUS,RP0                                  
                 MOVLW           07
                 MOVWF           CMCON
                 CLRF            H2
                 CLRF            H1
                 CLRF            M2
                 CLRF            M1
                 CLRF            KEY
                 MOVLW           01
                 MOVWF           N
                 MOVLW           H'78'
                 MOVWF           MIN
                 BSF             INTCON,GIE
START            MOVF            N,W              ;   
                 ADDLW           H'20'
                 BCF             STATUS,IRP
                 MOVWF           FSR
                 MOVF            INDF,W
                 CALL            SEGMENT
                 CLRF            PORTA
                 MOVWF           PORTB
                 BTFSC           SEG_H,0
                 BSF             PORTB,0
                 MOVF            N,W
                 BTFSS           N,0              ;  
                 MOVWF           PORTA            
                 MOVF            H2,F
                 BTFSS           STATUS,Z
                 MOVWF           PORTA
                 MOVF            KEY,F            ; 
                 BTFSS           STATUS,Z         
                 GOTO            LB1
                 BTFSS           PORTA,4          
                 GOTO            LB1
                 MOVF            N,W
                 MOVWF           KEY
LB1              RLF             N,F
                 BTFSS           N,4
                 GOTO            START
                 MOVLW           01
                 MOVWF           N
IND_OFF          BTFSS           PORTA,5          ; 
                 GOTO            START
                 CLRF            PORTA
                 CLRF            PORTB
                 GOTO            IND_OFF
; 
CLOCK            MOVWF           W_TMP            ;  
                 SWAPF           STATUS,W
                 BCF             STATUS,RP0
                 MOVWF           STATUS_TMP                
                 BCF             INTCON,T0IF
                 BTFSC           MIN,0            ; 
                 BCF             SEG_H,0
                 BTFSS           MIN,0
                 BSF             SEG_H,0 
                 MOVF            KEY,F            ;  
                 BTFSC           STATUS,Z
                 GOTO            MINUTA
                 BTFSC           KEY,1
                 CALL            PLUS1
                 BTFSC           KEY,2
                 CALL            PLUS
                 BTFSC           KEY,3
                 CALL            KORR
                 CLRF            KEY
MINUTA           DECFSZ          MIN,F            ; 
                 GOTO            ENDCLOCK
                 MOVLW           H'78'
                 MOVWF           MIN
                 CALL            PLUS
ENDCLOCK         SWAPF           STATUS_TMP,W     ;  
                 MOVWF           STATUS
                 SWAPF           W_TMP,F
                 SWAPF           W_TMP,W
                 RETFIE
PLUS             INCF            M1,F             ; 
                 MOVF            M1,W
                 BCF             STATUS,DC
                 ADDLW           06
                 BTFSS           STATUS,DC
                 GOTO            ENDPLUS
                 CLRF            M1
                 INCF            M2,F
                 MOVF            M2,W
                 BCF             STATUS,DC
                 ADDLW           H'0A'
                 BTFSS           STATUS,DC
                 GOTO            ENDPLUS
                 CLRF            M2
                 INCF            H1,F
                 MOVF            H1,W
                 BCF             STATUS,DC
                 ADDLW           06
                 BTFSS           STATUS,DC
                 GOTO            ENDPLUS
                 CLRF            H1
                 INCF            H2,F               
ENDPLUS          MOVLW           02
                 SUBWF           H2,W
                 BTFSS           STATUS,Z
                 GOTO            LB2
                 MOVLW           04
                 SUBWF           H1,W
                 BTFSS           STATUS,Z
                 GOTO            LB2
                 CLRF            H2
                 CLRF            H1
LB2              RETURN
PLUS1            INCF            H1,F               ;   1
                 MOVF            H1,W
                 BCF             STATUS,DC
                 ADDLW           06
                 BTFSS           STATUS,DC
                 GOTO            ENDPLUS1
                 CLRF            H1
                 INCF            H2,F
ENDPLUS1         MOVLW           02
                 SUBWF           H2,W
                 BTFSS           STATUS,Z
                 GOTO            LB3
                 MOVLW           04
                 SUBWF           H1,W
                 BTFSS           STATUS,Z
                 GOTO            LB3
                 CLRF            H2
                 CLRF            H1
LB3              RETURN
KORR             CLRF            TMR0               ; 
                 MOVF            M2,W
                 SUBLW           2
                 BTFSS           STATUS,C
                 CALL            PLUS1
                 CLRF            M1
                 CLRF            M2
                 MOVLW           H'78'
                 MOVWF           MIN
                 RETURN
                 END


                 
                                  
                 
                 
